package com.kdanmobile.reader.screen.adapter

import android.text.Html
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import com.kdanmobile.reader.R
import com.kdanmobile.reader.screen.model.SearchResultInfo
import java.util.ArrayList

class SearchAdapter(private var width: Int): BaseAdapter() {
    private var list: MutableList<SearchResultInfo>
    private var selected = -1

    init {
        this.width = width
        list = ArrayList()
    }

    fun clear() {
        list.clear()
    }

    fun add(list: List<SearchResultInfo>) {
        this.list.addAll(list)
    }

    override fun getCount(): Int {
        return list.size
    }

    override fun getItem(position: Int): Any {
        return list[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    fun setSelected(position: Int) {
        this.selected = position
        notifyDataSetChanged()
    }

    override fun getView(position: Int, view: View?, parent: ViewGroup): View {
        var view = view
        val item = list[position]
        val hv: HolderView
        if (view == null) {
            view = LayoutInflater.from(parent.context).inflate(R.layout.item_search, null)
            hv = HolderView()
            hv.tv_result = view!!.findViewById<View>(R.id.tv_fragmentPdfReaderSearchLvItem_result) as TextView
            hv.tv_page = view.findViewById<View>(R.id.tv_fragmentPdfReaderSearchLvItem_page) as TextView
            hv.view = view.findViewById(R.id.view_fragmentPdfReaderSearchLvItem_selected)
            hv.rl = view .findViewById<View>(R.id.rl_fragmentPdfReaderSearchLvItem_) as RelativeLayout
            val params = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT)
            params.leftMargin = 21 * width / 800
            params.rightMargin = 21 * width / 800
            params.topMargin = 8 * width / 800
            hv.rl!!.layoutParams = params
            view.tag = hv
        } else {
            hv = view.tag as HolderView
        }

        if (selected == position) {
            hv.view!!.setBackgroundResource(R.drawable.rectangle_6633b5e5)
        } else {
            hv.view!!.setBackgroundResource(R.drawable.rectangle_0000)
        }

        hv.tv_result!!.text = Html.fromHtml(item.result)
        hv.tv_page!!.text = "" + (item.page + 1)

        return view
    }

    private inner class HolderView {
        var rl: RelativeLayout? = null
        var tv_result: TextView? = null
        var tv_page: TextView? = null
        var view: View? = null
    }
}
